% Generating tomography problem instances (for B-Prolog)
% by Neng-Fa Zhou, January 10, 2011

go:-
    global_set(instance_no,1),
    gen(50,10),
    gen(100,10),
    gen(150,10),
    gen(200,10),
    gen(250,10).

gen(N,NInsts):-
    foreach(_ in 1..NInsts, gen(N)).

gen(N):-
    global_get(instance_no,I),
    I1 is I+1,
    global_set(instance_no,I1),
    number_codes(I,ICodes),
    append("../instances/",ICodes,"-tomography-0-0.asp",NameCodes),
    atom_codes(Name,NameCodes),
    tell(Name),
    format("max_node_num(~w).~n",[N]),
    M is 10*N,
    format("max_traceroute_num(~w).~n",[M]),
    foreach(R in 1..10*N,gen_route(R,N)),
    told.

gen_route(R,N):-
    Seed is R*N,
    X is random(Seed) mod N+1,
    gen_route(R,N,[X]).

gen_route(R,N,Nodes):-
    X is random mod N+1,
    (member(X,Nodes)->
     foreach(Node in Nodes,format("traceroute(~w,~w).~n",[R,Node]));
     gen_route(R,N,[X|Nodes])).

    
    
    


    
    
